//+------------------------------------------------------------------+
//|                                              dex_Angle_MA_v3.mq4 |
//|                                                        GrayMan77 |
//|                                                                  |
//|   - Akadex.                                                  |
//|                                                                  |
//|              |
//|  (    ):                            |
//|  -      -        |
//|     ;                                                   |
//|  -      -        |
//|        ,     ;          |
//|  -   (Close)   ,  |
//|          ,   |
//|         ()                       |
//|                                                                  |
//|       : |
//|  .                                                        |
//|                                                                  |
//|  v3 -  .                                          |
//|  |
//+------------------------------------------------------------------+
#property copyright "Akadex & GrayMan77"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Aqua
#property indicator_color3 Yellow
#property indicator_color4 White

//---- input parameters
extern int       MA_Period=24;
extern int       MA_Method=0;
extern int       MA_Price=0;


//---- buffers
double ExtMapBuffer1[];

double red[],blue[],yellow[],white[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,red);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,blue);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,yellow);
   
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,white);
   
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  int limit,i;
  int    counted_bars=IndicatorCounted();
  double MA,MA1,MA2,MA3;
  double delta,delta1,delta2;
  double Line;
//----
  
  //----    
   if(counted_bars<0) return(-1);
   
   //----     
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   if(limit>Bars-MA_Period) 
     {
     limit=Bars-MA_Period-3;
     ExtMapBuffer1[Bars-MA_Period]=iMA(NULL,0,MA_Period,0,MA_Method,MA_Price,Bars-MA_Period);
     ExtMapBuffer1[Bars-MA_Period-1]=iMA(NULL,0,MA_Period,0,MA_Method,MA_Price,Bars-MA_Period-1);
     ExtMapBuffer1[Bars-MA_Period-2]=iMA(NULL,0,MA_Period,0,MA_Method,MA_Price,Bars-MA_Period-2);
     }
   
   for(i=limit;i>=0;i--)
     {
     MA=iMA(NULL,0,MA_Period,0,MA_Method,MA_Price,i);
     MA1=iMA(NULL,0,MA_Period,0,MA_Method,MA_Price,i+1);
     MA2=iMA(NULL,0,MA_Period,0,MA_Method,MA_Price,i+2);
     //MA3=iMA(NULL,0,MA_Period,0,MA_Method,MA_Price,i+3);
     
     delta=MA-MA1;
     delta1=MA1-MA2;
     //delta2=MA2-MA3;
     
     //   (  ) -    
     if((delta>0 && delta1<=0) || (delta<0 && delta1>=0))
       {
       ExtMapBuffer1[i]=MA;
       ExtMapBuffer1[i+1]=MA1;  //    ( 1- ) !!!!!
                white[i]=MA;
                white[i+1]=MA1;
       
       continue;
       }
     
     //     
     Line=2*ExtMapBuffer1[i+1]-ExtMapBuffer1[i+2];
     //Line=2*MA1-MA2;
     
     //   
     if(delta>=0)
       {
       if(MA>Line) 
       {ExtMapBuffer1[i]=MA;  //   
        white[i]=MA;
       }
        else 
         {
         //  2      
         if(ExtMapBuffer1[i+2]<MA2) 
         {ExtMapBuffer1[i]=MA;  //   
                  white[i]=MA;
         }
          else 
          {ExtMapBuffer1[i]=2.*ExtMapBuffer1[i+1]-ExtMapBuffer1[i+2];  //    
          if(MA1>=MA) red[i]=ExtMapBuffer1[i]; else blue[i]=ExtMapBuffer1[i];
          
          }
         }
       
       //   
       if(Close[i+1]<ExtMapBuffer1[i+1]) 
       {ExtMapBuffer1[i]=ExtMapBuffer1[i+1];  //   
       yellow[i]=ExtMapBuffer1[i];
       }
       }
     
     //   
     if(delta<0)
       {
       if(MA<Line) {ExtMapBuffer1[i]=MA;  //   
                  white[i]=MA;
                  }
        else
         {
         //  2      
         if(ExtMapBuffer1[i+2]>MA2) 
         {ExtMapBuffer1[i]=MA;  //   
                  white[i]=MA;
         }
          else {ExtMapBuffer1[i]=2.*ExtMapBuffer1[i+1]-ExtMapBuffer1[i+2];  //    
         if(MA1>=MA) red[i]=ExtMapBuffer1[i]; else blue[i]=ExtMapBuffer1[i];
         }
         }
       
       //   
       if(Close[i+1]>ExtMapBuffer1[i+1]) 
       {ExtMapBuffer1[i]=ExtMapBuffer1[i+1];  //   
       yellow[i]=ExtMapBuffer1[i];
       }
       }
     
     }
  
  
//----
  return(0);
  }
//+------------------------------------------------------------------+